/*
 *    Poller.java
 *    Copyright (C) 2000 Stuart Yeates 
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// the package we're in
package org.nzdl.gsdl.ptp;

// java standard library classes used
import java.io.IOException;
import java.io.Reader;
import java.io.InputStreamReader;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.Serializable;
//import java.io.;
import java.util.*;
import java.net.*;

/**
 * Class Listener listens for connections from peers.
 *
 * Listener exists in it's own Thread 
 *
 * The static Node.knownList is consulted about which peers are
 * known.
 *
 * @author stuart yeates (say1@cs.waikato.ac.nz)
 * @version $Revision: 2136 $
 * @see org.nzdl.gsdl.ptp.PTP
 * @see org.nzdl.gsdl.ptp.Connection
 * @see org.nzdl.gsdl.ptp.Node
 * @see org.nzdl.gsdl.ptp.Node#knownList
 * @see java.lang.Thread
 */

public class Listener extends Thread {
  /** What port are we listening on? */
  int port = 4567;

  /** The no-args constructor */
  public Listener() {

  }

  /** 
   * Start the Listener. 
   * 
   * Only returns if interrupted or an Error is thrown.
   */
  public void run() {
      try {
	System.err.println("Listerer: creating serversocket.");
	ServerSocket server = new ServerSocket (port, 5);
        while (true) {
	  try { 
	    // blocking accept ...
	    System.err.println("Listerer: blocking accept.");
	    Socket socket = server.accept();
	    System.err.println("Listerer: connection accepted.");
	    Connection connection = new Connection(socket);
	    connection.run();
	    System.err.println("Listerer: connection forked.");
	  } catch (Exception exception) {
	    System.err.println("caught exception: "+exception);
	    return;
	  }
	}
      } catch (Exception exception) {
	System.err.println("caught exception: "+exception);
	return;
      }
  }

}





